//
//  main.cpp
//  problem 4
//
//  Created by 廖偉宏 on 2016/4/11.
//  Copyright © 2016年 PD2016. All rights reserved.
//

#include <iostream>
using namespace std;
int main() {
    // get n and m
    int n=0, m=0;
    cin>>n>>m;
    int* edgeNum=new int [n];
    for(int i=0; i<n; i++) {
        edgeNum[i]=0;
    }
    
    // temporarily store the edges to the array edge and count the degree of every vertex
    int* edge[2];
    edge[0]=new int [m];
    edge[1]=new int [m];
    for(int i=0; i<m; i++) {
        cin>>edge[0][i]>>edge[1][i];
        edgeNum[edge[0][i]-1]++;
        edgeNum[edge[1][i]-1]++;
    }
    
    //declare the map array using the degree counted above
    int** map=new int* [n];
    for(int i=0; i<n; i++) {
        map[i]=new int [edgeNum[i]];
        for(int j=0; j<edgeNum[i]; j++) {
            map[i][j]=-1;
        }
    }
    
    // put the edge to the correct place
    // e.g. (3, 5) --> map[2][j]=5, map[4][j]=3
    for(int i=0; i<m; i++) {
        for(int j=0; j<edgeNum[edge[0][i]-1]; j++) {
            if(map[edge[0][i]-1][j]==-1) {
                map[edge[0][i]-1][j]=edge[1][i];
                break;
            }
        }
        for(int j=0; j<edgeNum[edge[1][i]-1]; j++) {
            if(map[edge[1][i]-1][j]==-1) {
                map[edge[1][i]-1][j]=edge[0][i];
                break;
            }
        }
    }
    // delete the edge array since the information is stored in the map array now
    delete[] edge[0];
    delete[] edge[1];
    
    // split the route to several pieces
    // e.g. 3->5->4  =>  3->5, 5->4
    int start=0;
    int next=0;
    cin>>start;
    while(cin>>next) {
        // find the edge
        bool exist=false;
        for(int i=0; i<edgeNum[start-1]; i++) {
            if(map[start-1][i]==next) {
                exist=true;
            }
        }
        // if not exists, print it out
        if(!exist) {
            if(start<next) {
                cout<<start<<" "<<next<<"\n";
            } else {
                cout<<next<<" "<<start<<"\n";
            }
        }
        start=next;
    }
    
    // delete all the dynamic array
    delete[] edgeNum;
    for(int i=0; i<n; i++) {
        delete[] map[i];
    }
    delete[] map;
    
    return 0;
}